Magisk/scripts/magisk_uninstaller.sh

150 lines
4.8 KiB
Bash
Raw Normal View History

2017-06-03 18:03:36 +02:00
#!/system/bin/sh
##########################################################################################
#
# Magisk Uninstaller
# by topjohnwu
2017-07-24 20:02:19 +02:00
#
2017-06-03 18:03:36 +02:00
# This script can be placed in /cache/magisk_uninstaller.sh
# The Magisk main binary will pick up the script, and uninstall itself, following a reboot
# This script can also be used in flashable zip with the uninstaller_loader.sh
2017-07-24 20:02:19 +02:00
#
2017-07-09 18:17:34 +02:00
# This script will try to do restoration with the following:
# 1-1. Find and restore the original stock boot image dump (OTA proof)
# 1-2. If 1-1 fails, restore ramdisk from the internal backup
# (ramdisk fully restored, not OTA friendly)
# 1-3. If 1-2 fails, it will remove added files in ramdisk, however modified files
2017-07-24 20:02:19 +02:00
# are remained modified, because we have no backups. By doing so, Magisk will
2017-07-09 18:17:34 +02:00
# not be started at boot, but this isn't actually 100% cleaned up
# 2. Remove all Magisk related files
# (The list is LARGE, most likely due to bad decision in early versions
# the latest versions has much less bloat to cleanup)
2017-06-03 18:03:36 +02:00
#
##########################################################################################
2017-06-03 14:19:01 +02:00
# Call ui_print_wrap if exists, or else simply use echo
# Useful when wrapped in flashable zip
ui_print_wrap() {
type ui_print >/dev/null 2>&1 && ui_print "$1" || echo "$1"
2017-02-05 20:22:37 +01:00
}
2017-07-09 18:17:34 +02:00
# Call abort if exists, or else show error message and exit
# Essential when wrapped in flashable zip
abort_wrap() {
type abort >/dev/null 2>&1
if [ $? -ne 0 ]; then
ui_print_wrap "$1"
exit 1
else
abort "$1"
2017-02-05 20:22:37 +01:00
fi
}
2017-07-09 18:17:34 +02:00
if [ ! -d $MAGISKBIN -o ! -f $MAGISKBIN/magiskboot -o ! -f $MAGISKBIN/util_functions.sh ]; then
ui_print_wrap "! Cannot find $MAGISKBIN"
exit 1
fi
[ -z $BOOTMODE ] && BOOTMODE=false
MAGISKBIN=/data/magisk
CHROMEDIR=$MAGISKBIN/chromeos
2017-02-05 20:22:37 +01:00
2017-07-09 18:17:34 +02:00
# Default permissions
umask 022
# Load utility functions
. $MAGISKBIN/util_functions.sh
2017-02-05 20:22:37 +01:00
# Find the boot image
find_boot_image
2017-07-09 18:17:34 +02:00
[ -z $BOOTIMAGE ] && abort "! Unable to detect boot image"
2017-02-05 20:22:37 +01:00
2017-06-03 14:19:01 +02:00
ui_print_wrap "- Found Boot Image: $BOOTIMAGE"
2017-02-05 20:22:37 +01:00
2017-06-03 18:03:36 +02:00
cd $MAGISKBIN
2017-02-05 20:22:37 +01:00
2017-06-03 14:19:01 +02:00
ui_print_wrap "- Unpacking boot image"
2017-07-09 18:17:34 +02:00
./magiskboot --unpack "$BOOTIMAGE"
2017-07-18 09:07:39 +02:00
CHROMEOS=false
case $? in
1 )
abort_wrap "! Unable to unpack boot image"
;;
2 )
CHROMEOS=true
;;
3 )
ui_print_wrap "! Sony ELF32 format detected"
abort_wrap "! Please use BootBridge from @AdrianDC to flash Magisk"
;;
4 )
ui_print_wrap "! Sony ELF64 format detected"
abort_wrap "! Stock kernel cannot be patched, please use a custom kernel"
esac
2017-02-05 20:22:37 +01:00
2017-07-09 18:17:34 +02:00
# Update our previous backup to new format if exists
2017-03-12 11:13:58 +01:00
if [ -f /data/stock_boot.img ]; then
2017-07-24 20:02:19 +02:00
SHA1=`./magiskboot --sha1 /data/stock_boot.img 2>/dev/null`
2017-03-12 11:13:58 +01:00
STOCKDUMP=/data/stock_boot_${SHA1}.img
mv /data/stock_boot.img $STOCKDUMP
2017-07-09 18:17:34 +02:00
./magiskboot --compress $STOCKDUMP
fi
2017-02-05 20:22:37 +01:00
2017-03-12 11:13:58 +01:00
# Detect boot image state
2017-07-09 18:17:34 +02:00
./magiskboot --cpio-test ramdisk.cpio
2017-03-12 11:13:58 +01:00
case $? in
2017-07-09 18:17:34 +02:00
0 ) # Stock boot
2017-06-03 18:03:36 +02:00
ui_print_wrap "- Stock boot image detected!"
2017-06-03 14:19:01 +02:00
ui_print_wrap "! Magisk is not installed!"
2017-03-12 11:13:58 +01:00
exit
;;
2017-07-09 18:17:34 +02:00
1 ) # Magisk patched
2017-06-03 18:03:36 +02:00
ui_print_wrap "- Magisk patched image detected!"
2017-03-12 11:13:58 +01:00
# Find SHA1 of stock boot image
[ -z $SHA1 ] && SHA1=`./magiskboot --cpio-stocksha1 ramdisk.cpio`
2017-07-09 18:17:34 +02:00
[ ! -z $SHA1 ] && STOCKDUMP=/data/stock_boot_${SHA1}.img
2017-03-12 11:13:58 +01:00
if [ -f ${STOCKDUMP}.gz ]; then
2017-06-03 14:19:01 +02:00
ui_print_wrap "- Boot image backup found!"
2017-07-09 18:17:34 +02:00
./magiskboot --decompress ${STOCKDUMP}.gz stock_boot.img
2017-03-12 11:13:58 +01:00
else
2017-06-03 14:19:01 +02:00
ui_print_wrap "! Boot image backup unavailable"
ui_print_wrap "- Restoring ramdisk with backup"
2017-07-09 18:17:34 +02:00
./magiskboot --cpio-restore ramdisk.cpio
./magiskboot --repack $BOOTIMAGE stock_boot.img
2017-03-12 11:13:58 +01:00
fi
;;
2017-06-03 18:03:36 +02:00
2 ) # Other patched
2017-07-09 18:17:34 +02:00
ui_print_wrap "! Boot image patched by other programs!"
abort_wrap "! Cannot uninstall with this uninstaller"
2017-03-12 11:13:58 +01:00
;;
esac
# Sign chromeos boot
2017-07-18 09:07:39 +02:00
if $CHROMEOS; then
2017-06-03 18:03:36 +02:00
echo > empty
2017-07-18 09:07:39 +02:00
./chromeos/futility vbutil_kernel --pack stock_boot.img.signed \
--keyblock ./chromeos/kernel.keyblock --signprivate ./chromeos/kernel_data_key.vbprivk \
2017-06-03 18:03:36 +02:00
--version 1 --vmlinuz stock_boot.img --config empty --arch arm --bootloader empty --flags 0x1
rm -f empty stock_boot.img
2017-03-12 12:22:15 +01:00
mv stock_boot.img.signed stock_boot.img
2017-02-05 20:22:37 +01:00
fi
2017-06-03 14:19:01 +02:00
ui_print_wrap "- Flashing stock/reverted image"
2017-07-09 18:17:34 +02:00
if [ -L "$BOOTIMAGE" ]; then
dd if=stock_boot.img of="$BOOTIMAGE" bs=4096
2017-06-03 18:03:36 +02:00
else
2017-07-09 18:17:34 +02:00
cat stock_boot.img /dev/zero | dd of="$BOOTIMAGE" bs=4096 >/dev/null 2>&1
2017-06-03 18:03:36 +02:00
fi
rm -f stock_boot.img
2017-02-05 20:22:37 +01:00
2017-06-03 14:19:01 +02:00
ui_print_wrap "- Removing Magisk files"
2017-02-05 20:22:37 +01:00
rm -rf /cache/magisk.log /cache/last_magisk.log /cache/magiskhide.log /cache/.disable_magisk \
/cache/magisk /cache/magisk_merge /cache/magisk_mount /cache/unblock /cache/magisk_uninstaller.sh \
2017-06-07 21:20:49 +02:00
/data/Magisk.apk /data/magisk.apk /data/magisk.img /data/magisk_merge.img /data/magisk_debug.log \
2017-07-18 21:24:07 +02:00
/data/busybox /data/magisk /data/custom_ramdisk_patch.sh /data/property/*magisk* \
2017-07-18 09:07:39 +02:00
/data/app/com.topjohnwu.magisk* /data/user/*/com.topjohnwu.magisk 2>/dev/null
2017-02-05 20:22:37 +01:00
2017-03-12 11:13:58 +01:00
$BOOTMODE && reboot